<template>
  <page>
    <a-collapse
      v-if="sections.length > 0 && !fetching"
      v-model="activeKey"
    >
      <a-collapse-panel
        v-for="(item, i) in sections"
        :key="`${i}`"
        :header="`Seção ${i + 1}`"
      >
        <a-timeline>
          <!-- <a-timeline-item color="green">
            <strong>Situação: </strong>Ativa
          </a-timeline-item> -->
          <a-timeline-item>
            <strong>Título: </strong>{{ item.text }}
          </a-timeline-item>
          <a-timeline-item>
            <strong>Ações: </strong>
            <div class="actions">
              <a-popconfirm
                title="Tem certeza que deseja deletar?"
                ok-text="Sim. Quero deletar."
                cancel-text="Não"
                @confirm="deleteSection(item._id)"
              >
                <a-button
                  type="danger"
                  icon="delete"
                  :disabled="deleting"
                >
                  <span v-if="deleting">
                    <a-icon type="loading" />
                  </span>
                  <span v-else>Deletar</span>
                </a-button>
              </a-popconfirm>
            </div>
          </a-timeline-item>

          <a-timeline-item>
            <strong>Conteúdo: </strong>
            <div>
              <span v-html="item.content" />
            </div>
          </a-timeline-item>
        </a-timeline>
      </a-collapse-panel>
    </a-collapse>

    <no-data v-if="sections.length === 0 && !fetching">
      Nenhuma seção foi cadastrada no sistema
    </no-data>

    <page-loading v-if="fetching" />
  </page>
</template>

<script>
export default {
  name: 'News',
  data() {
    return {
      activeKey: ['1'],
      sections: [],
      deleting: false,
      fetching: false,
    };
  },
  async created() {
    try {
      this.fetching = true;
      const fetch = await this.$http.get('/sections');
      this.sections = fetch.data;
      this.fetching = false;
    } catch (error) {
      this.fetching = false;
      this.$message.error('Ocorreu um erro ao tentar buscar os serviços. Tente novamente mais tarde.');
    }
  },
  methods: {
    async deleteSection(id) {
      try {
        this.deleting = true;
        await this.$http.delete(`/sections/${id}`);
        this.updateSectionsById(id);
        this.$message.success('Seção deletada com sucesso');
        this.deleting = false;
      } catch (error) {
        this.deleting = false;
        this.$message.error('Ocorreu um erro ao deletar a seção. Tente novamente mais tarde.');
      }
    },
    updateSectionsById(id) {
      // eslint-disable-next-line no-underscore-dangle
      this.sections = this.sections.filter(section => section._id !== id);
    },
  },
};
</script>

<style lang="stylus" scoped>
.ant-timeline-item-last
  padding 0

.actions
  margin-top 1rem

  .ant-btn-primary
    margin-right 2rem
</style>
